<?php
/* Copyright (c) 2013, SWITCH */

require_once 'config.php';

require_once 'lib/SessionModel.php';
$sessionModel = new SessionModel;

$app->error($htmlErrorHandler);

$app->get('/', function() use($app, $sessionModel){
	$uniqueId = $_SERVER['uniqueID'];

	if(!$uniqueId){

		$app->render('error.tpl', array(
			'resourceRoot' => RESOURCE_ROOT,
			'message' => 'You are not logged in with AAI. This is likely due to a server misconfiguration. Please contact the webmaster.',
			'title' => 'Error - Mobile Proxy Device Administration',
			'h1' => 'Error'
		), 403);

	} else {

		$logins =$sessionModel->getSessions($uniqueId);
		if(!$logins){
			$app->flashNow('info', 'You are currently not logged in with any mobile devices');
		}

		$app->render('admin.tpl', array(
			'resourceRoot' => RESOURCE_ROOT,
			'uniqueId' => $_SERVER['uniqueID'],
			'logins' => $logins,
			'title' => 'Mobile Proxy Device Administration',
			'h1' => 'Mobile Proxy Device Administration',
			'user' => $_SERVER['givenName'].' '.$_SERVER['surname']
		));
	}

});

$app->get('/revoke/:id', function($id) use($app, $sessionModel){
	$accessToken = $sessionModel->getAccessToken($id);
	$app->getLog()->info("Deleted access_token '$accessToken'");
	$sessionModel->revokeAccessToken($accessToken);
	$app->flash('info', 'Login deleted.');
	$app->redirect(RESOURCE_ROOT.'admin.php');
});

$app->run();
