<?php
/* Copyright (c) 2013, SWITCH */

class Util{

	/*
	 * Queries the Identity Provider associated with the Persistent Id mapped to the given accessToken
	 * for AAI attributes.
	 */
	public static function attributeQuery($accessToken, $sessionModel){
		$persistentId = $sessionModel->getPersistentId($accessToken);

		//return a dummy response
		//return self::getDummyAttributes($persistentId);
		
		list( $entityId, /*skip*/, $nameId ) = explode('!', $persistentId);

		$url = "https://localhost/Shibboleth.sso/AttributeQuery?entityID=".urlencode($entityId)."&nameId=".urlencode($nameId);
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); //TODO remove this for security
		$re = curl_exec($ch);

		$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if($httpcode == 500){
			throw new Exception("Your Identity Provider returned a 500. Make sure you have the Attribute Query plugin up and running.");
		} elseif(!$re){
			throw new Exception("A problem occurred in attributeQuery: HTTP status code $httpcode, curl: ".curl_errno($ch)."response: $re");
		}

		curl_close($ch);

		$out = json_decode($re);

		return $out;
	}

	/*
	 * returns a set of dummy attributes in case you want to test the server without installing
	 * the attribtue query addon into your IdP
	 */
	private static function getDummyAttributes($persistentId){
		return array(
			'persistent-id' => $persistentId,
			'uniqueID' => 'trulyUniqueId@switch.ch',
			'givenName' => 'Wilhelm',
			'surname' => 'Tell',
			'mail' => 'wilhelm.tell@switch.ch',
			'homeOrganization' => 'switch.ch',
			'dateOfBirth' => '19800503',
			'homeOrganizationType' => 'others',
			'affiliation' => 'member;staff;marksman',
			'postalAddress' => 'SWITCH$Werdstrasse 2$CH-8004 Zürich'
		);
	}


	/*
	 * Returns the first 6 characters of a token for displaying it without giving it away
	 */
	public static function truncateToken($token){
		return substr($token,0,6).'*';
	}
}
